uniform sampler2D fields;
uniform float dt;
uniform float dx;
uniform float dy;
uniform int resI;
uniform int resJ;

void main() {
   vec4 field = texture2D(fields, gl_TexCoord[0].st);
   
   vec2 vel = field.xy;
   vec2 cellPos = gl_TexCoord[0].st;
   vec2 prevPos = cellPos - dt * vel;
   prevPos = clamp(prevPos, vec2(0.0, 0.0), vec2(1.0, 1.0));
   
   vec2 rbl = floor(prevPos * vec2(resI + 2, resJ + 2) - vec2(0.5, 0.5)) +
      vec2(0.5, 0.5);
   vec2 dbl = rbl * vec2(dx, dy);
   
   vec2 vx = vec2(dx, 0.0);
   vec2 vy = vec2(0.0, dy);
   
   vec4 fieldBL = texture2D(fields, dbl);
   vec4 fieldBR = texture2D(fields, dbl + vx);
   vec4 fieldTR = texture2D(fields, dbl + vx + vy);
   vec4 fieldTL = texture2D(fields, dbl + vy);
   
   float px = (prevPos.x - dbl.x) / dx;
   vec4 bottom = mix(fieldBL, fieldBR, px);
   vec4 top = mix(fieldTL, fieldTR, px);
   
   float py = (prevPos.y - dbl.y) / dy;
   vec4 val = mix(bottom, top, py);
   
   //gl_FragColor = vec4(0.0, 0.0, 1.0, 100.0);
   gl_FragColor = val;
}
