uniform sampler2D heights;
uniform sampler2D fields;
uniform float dx;
uniform float dy;

void main() {
   vec4 field = texture2D(fields, gl_TexCoord[0].st);
   
   vec2 vx = vec2(dx, 0.0);
   vec2 vy = vec2(0.0, dy);
   
   vec4 fieldLeft = texture2D(fields, gl_TexCoord[0].st - vx);
   vec4 fieldRight = texture2D(fields, gl_TexCoord[0].st + vx);
   vec4 fieldBottom = texture2D(fields, gl_TexCoord[0].st - vy);
   vec4 fieldTop = texture2D(fields, gl_TexCoord[0].st + vy);

   float fx = (fieldRight.x - fieldLeft.x) / 2.0 * dx;
   float fy = (fieldTop.y - fieldBottom.y) / 2.0 * dy;
   float div = -(fx + fy);
   
   vec4 heightLeft = texture2D(heights, gl_TexCoord[0].st - vx);
   vec4 heightRight = texture2D(heights, gl_TexCoord[0].st + vx);
   vec4 heightBottom = texture2D(heights, gl_TexCoord[0].st - vy);
   vec4 heightTop = texture2D(heights, gl_TexCoord[0].st + vy);
 
   float val = (div + (heightLeft.a + heightRight.a + heightBottom.a +
      heightTop.a)) / 4.0;
   gl_FragColor = vec4(0.0, 0.0, 0.0, val);
}
