uniform sampler2D fields;
uniform sampler2D newFields;
uniform float dt;
uniform float dx;
uniform float dy;

const float DIFFUSION_RATE = 10.0;

void main() {
   vec4 field = texture2D(fields, gl_TexCoord[0].st);
   
   vec2 vx = vec2(dx, 0.0);
   vec2 vy = vec2(0.0, dy);
   
   vec4 newFieldLeft = texture2D(newFields, gl_TexCoord[0].st - vx);
   vec4 newFieldRight = texture2D(newFields, gl_TexCoord[0].st + vx);
   vec4 newFieldBottom = texture2D(newFields, gl_TexCoord[0].st - vy);
   vec4 newFieldTop = texture2D(newFields, gl_TexCoord[0].st + vy);
   
   float a = dt * DIFFUSION_RATE;
   gl_FragColor = (field + a * (newFieldLeft + newFieldRight + newFieldBottom +
      newFieldTop)) / (1.0 + 4.0 * a);
   //gl_FragColor = vec4(1.0, 1.0, 0.0, 100.0);
}
