uniform sampler2D curls;
uniform float dx;
uniform float dy;

void main() {
   vec4 curl = texture2D(curls, gl_TexCoord[0].st);
   
   vec2 vx = vec2(dx, 0.0);
   vec2 vy = vec2(0.0, dy);
   
   vec4 curlLeft = texture2D(curls, gl_TexCoord[0].st - vx);
   vec4 curlRight = texture2D(curls, gl_TexCoord[0].st + vx);
   vec4 curlBottom = texture2D(curls, gl_TexCoord[0].st - vy);
   vec4 curlTop = texture2D(curls, gl_TexCoord[0].st + vy);
  
   float gx = (abs(curlRight.a) - abs(curlLeft.a)) / (2.0 * dx);
   float gy = (abs(curlTop.a) - abs(curlBottom.a)) / (2.0 * dy);
      
   //gl_FragColor = vec4(0.0, 0.0, 1.0, 100.0);
   vec2 result = vec2(gx, gy);
   if (length(result) > 0.0)
      result = normalize(result);
    
   gl_FragColor = vec4(result, 0.0, curl.a);
}
