uniform sampler2D heights;
uniform sampler2D fields;
uniform float dx;
uniform float dy;

void main() {
   vec4 field = texture2D(fields, gl_TexCoord[0].st);
   
   vec2 vx = vec2(dx, 0.0);
   vec2 vy = vec2(0.0, dy);
   
   vec4 heightLeft = texture2D(heights, gl_TexCoord[0].st - vx);
   vec4 heightRight = texture2D(heights, gl_TexCoord[0].st + vx);
   vec4 heightBottom = texture2D(heights, gl_TexCoord[0].st - vy);
   vec4 heightTop = texture2D(heights, gl_TexCoord[0].st + vy);
 
   float gx = (heightRight.a - heightLeft.a) / (2.0 * dx);
   float gy = (heightTop.a - heightBottom.a) / (2.0 * dy);

   vec2 grad = vec2(gx, gy);
   gl_FragColor = vec4(field.xy - grad, 0.0, field.a);
}
