uniform sampler2D fields;
uniform float dx;
uniform float dy;

void main() {
   vec4 field = texture2D(fields, gl_TexCoord[0].st);
   
   vec2 vx = vec2(dx, 0.0);
   vec2 vy = vec2(0.0, dy);
   
   vec4 fieldLeft = texture2D(fields, gl_TexCoord[0].st - vx);
   vec4 fieldRight = texture2D(fields, gl_TexCoord[0].st + vx);
   vec4 fieldBottom = texture2D(fields, gl_TexCoord[0].st - vy);
   vec4 fieldTop = texture2D(fields, gl_TexCoord[0].st + vy);
  
   float fyx = (fieldRight.y - fieldLeft.y) / (2.0 * dx);
   float fxy = (fieldTop.x - fieldBottom.x) / (2.0 * dy);
      
   //gl_FragColor = vec4(0.0, 0.0, 1.0, 100.0);
   gl_FragColor = vec4(0.0, 0.0, 0.0, fyx - fxy);
}
